/* A lexical scanner generated by flex */

/* scanner skeleton */

/* modified by Jim Kowalkowski to have everything declared static */

#define FLEX_SCANNER

#include <stdio.h>
#include <stdlib.h>

/* amount of stuff to slurp up with each read */
#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

/* returned upon end-of-file */
#define YY_END_TOK 0

/* copy whatever the last rule matched to the standard output */

/* cast to (char *) is because for 8-bit chars, yytext is (unsigned char *) */
/* this used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite()
 */
#define ECHO (void) fwrite( (char *) yytext, yyleng, 1, yyout )

/* gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#define YY_INPUT(buf,result,max_size) \
        if ( (result = read( fileno(yyin), (char *) buf, max_size )) < 0 ) \
            YY_FATAL_ERROR( "read() in flex scanner failed" );
#define YY_NULL 0

/* no semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */

/* #define yyterminate() return ( YY_NULL )  replaced by jbk */
static int yyterminate_internal( void );
#define yyterminate() return yyterminate_internal()

/* report a fatal error */

/* The funky do-while is used to turn this macro definition into
 * a single C statement (which needs a semi-colon terminator).
 * This avoids problems with code like:
 *
 *      if ( something_happens )
 *              YY_FATAL_ERROR( "oops, the something happened" );
 *      else
 *              everything_okay();
 *
 * Prior to using the do-while the compiler would get upset at the
 * "else" because it interpreted the "if" statement as being all
 * done when it reached the ';' after the YY_FATAL_ERROR() call.
 */

#define YY_FATAL_ERROR(msg) \
        do \
                { \
                (void) fputs( msg, stderr ); \
                (void) putc( '\n', stderr ); \
                exit( 1 ); \
                } \
        while ( 0 )

/* default yywrap function - always treat EOF as an EOF */
#define yywrap() 1

/* enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN
 */
#define BEGIN yy_start = 1 + 2 *

/* action number for EOF rule of a given start state */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* special action meaning "start processing a new file" */
#define YY_NEW_FILE \
        do \
                { \
                yy_init_buffer( yy_current_buffer, yyin ); \
                yy_load_buffer_state(); \
                } \
        while ( 0 )

/* default declaration of generated scanner - a define so the user can
 * easily add parameters - jbk added the static to YY_DECL
 */
#define YY_DECL static int yylex ( void )

/* code executed at the end of each rule */
#define YY_BREAK break;

#define YY_END_OF_BUFFER_CHAR 0

#ifndef YY_BUF_SIZE
#define YY_BUF_SIZE (YY_READ_BUF_SIZE * 2) /* size of default input buffer */
#endif

typedef struct yy_buffer_state *YY_BUFFER_STATE;

#define YY_CHAR unsigned char
# line 1 "../dbStatic/dbLex.l"
#define INITIAL 0
/*************************************************************************\
* Copyright (c) 2016 UChicago Argonne LLC, as Operator of Argonne
*     National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
*     Operator of Los Alamos National Laboratory.
* SPDX-License-Identifier: EPICS
* EPICS BASE is distributed subject to a Software License Agreement found
* in file LICENSE that is included with this distribution.
\*************************************************************************/
# line 49 "../dbStatic/dbLex.l"
#undef YY_INPUT
#define YY_INPUT(b,r,ms) (r=(*db_yyinput)((char *)b,ms))

static int yyreset(void)
{
    BEGIN INITIAL;
    return(0);
}

#define JSON 1
# line 62 "../dbStatic/dbLex.l"

/* done after the current pattern has been matched and before the
 * corresponding action - sets up yytext
 */
#define YY_DO_BEFORE_ACTION \
        yytext = yy_bp; \
	yyleng = yy_cp - yy_bp; \
        yy_hold_char = *yy_cp; \
        *yy_cp = '\0'; \
        yy_c_buf_p = yy_cp;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

/* return all but the first 'n' matched characters back to the input stream */
#define yyless(n) \
        do \
                { \
                /* undo effects of setting up yytext */ \
                *yy_cp = yy_hold_char; \
                yy_c_buf_p = yy_cp = yy_bp + n; \
                YY_DO_BEFORE_ACTION; /* set up yytext again */ \
                } \
        while ( 0 )

#define unput(c) yyunput( c, yytext )


struct yy_buffer_state
    {
    FILE *yy_input_file;

    YY_CHAR *yy_ch_buf;         /* input buffer */
    YY_CHAR *yy_buf_pos;        /* current position in input buffer */

    /* size of input buffer in bytes, not including room for EOB characters */
    int yy_buf_size;

    /* number of characters read into yy_ch_buf, not including EOB characters */
    int yy_n_chars;

    int yy_eof_status;          /* whether we've seen an EOF on this buffer */
#define EOF_NOT_SEEN 0
    /* "pending" happens when the EOF has been seen but there's still
     * some text process
     */
#define EOF_PENDING 1
#define EOF_DONE 2
    };

static YY_BUFFER_STATE yy_current_buffer;

/* we provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state"
 */
#define YY_CURRENT_BUFFER yy_current_buffer


/* yy_hold_char holds the character lost when yytext is formed */
static YY_CHAR yy_hold_char;

static int yy_n_chars;          /* number of characters read into yy_ch_buf */



#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

#ifndef YY_USER_INIT
#define YY_USER_INIT
#endif

/* jbk update
extern YY_CHAR *yytext;
extern int yyleng;
extern FILE *yyin, *yyout;
*/

static YY_CHAR *yytext; /* jbk added static */
static int yyleng; /* jbk added static */

static FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0; /* jbk added static */

#define YY_END_OF_BUFFER 41
typedef int yy_state_type;
static const short int yy_accept[221] =
    {   0,
        0,    0,    0,    0,   41,   39,   35,   35,   39,   34,
       21,   24,   25,   19,   26,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   22,   23,   39,
       39,   33,   30,   33,   32,   32,   33,   33,   33,   33,
       33,   33,    0,   36,   20,    0,   34,   21,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,    0,    0,   31,    0,    0,    0,
       31,    0,   33,   33,   32,   32,   33,   32,   32,   33,
       33,   32,   33,   33,   33,   33,   33,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,

       19,   19,   19,   19,   37,    0,    0,    0,    0,   38,
        0,    0,    0,    0,   33,   32,   33,   33,   32,   32,
       33,   32,   33,   33,   33,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   15,   10,    4,    2,   19,
       19,   19,   31,    0,    0,    0,    0,    0,    0,   33,
       32,   33,   32,   33,   33,   27,   28,   19,   14,   19,
       19,   19,   19,    7,   19,   19,   19,   19,   19,   19,
        0,    0,    0,    0,    0,    0,   33,   29,   19,   19,
        5,    8,    9,   19,   19,   19,   12,   19,   19,    0,
        0,    0,    0,    0,    0,   33,    3,   19,   19,   13,

        1,   19,   19,   19,    0,    0,   33,   19,   17,   19,
       19,   18,    0,    0,   19,   19,   16,   11,    6,    0
    } ;

static const YY_CHAR yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    2,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    4,    5,    6,    7,    5,    8,    5,    9,   10,
       11,    5,   12,   13,   12,   14,    5,   15,   16,   16,
       16,   16,   16,   16,   16,   16,   16,   17,   18,   18,
        5,   18,    5,    5,   19,   19,   19,   19,   20,   19,
       21,   21,   22,   21,   21,   21,   21,   23,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   24,   21,   21,
       17,   25,   17,    5,   21,    5,   26,   27,   28,   29,

       30,   31,   32,   33,   34,   21,   35,   36,   37,   38,
       39,   40,   21,   41,   42,   43,   44,   45,   21,   46,
       47,   21,   48,    5,   49,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,

        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5
    } ;

static const YY_CHAR yy_meta[50] =
    {   0,
        1,    1,    2,    3,    3,    3,    3,    3,    3,    3,
        3,    4,    3,    4,    5,    5,    6,    6,    5,    5,
        4,    4,    4,    4,    3,    5,    5,    5,    5,    5,
        5,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    3,    3
    } ;

static const short int yy_base[242] =
    {   0,
        0,    0,   49,    0,  500,  501,  501,  501,   96,    0,
        0,  501,  501,    0,  501,   71,  458,  465,   71,   69,
      456,  458,  461,  464,  467,  462,  465,  501,  501,  103,
      109,  100,  501,  104,  103,  110,    0,  452,  463,  462,
      443,  445,  126,  501,  501,  482,    0,    0,    0,  455,
      449,  452,  442,  435,  445,  448,  439,  446,  107,  437,
      436,  430,  109,  431,  125,  141,  501,  136,  135,  144,
      501,  145,    0,  139,  144,  156,  433,  147,  163,  169,
      179,  197,  427,  429,  408,  402,  385,  383,  383,  382,
      373,  372,  360,  366,  373,  364,  355,  351,  354,  344,

      352,  345,  341,  340,  501,    0,  150,  222,  239,  501,
        0,  148,  262,  279,  185,  172,  203,  188,  205,    0,
      339,    0,  330,  335,  338,  341,  316,  322,  328,  327,
      324,  322,  307,  307,  294,    0,    0,    0,    0,  296,
      294,  309,  501,  228,  296,  313,  301,  333,  350,  207,
      209,  217,  219,  296,  301,    0,    0,  287,    0,  278,
      290,  289,  277,    0,  280,  272,  272,  271,  254,  269,
        0,    0,  367,    0,    0,  384,  252,    0,  252,  258,
        0,    0,    0,  244,  251,  249,  233,  234,  237,    0,
        0,    0,    0,    0,    0,  221,    0,  236,  224,    0,

        0,  214,  234,  227,    0,    0,  209,  210,    0,  205,
      202,    0,    0,    0,  210,  209,    0,    0,    0,  501,
      415,  421,  427,  430,  436,  442,  445,  450,  456,  460,
      464,  231,  221,  211,  209,  191,  160,  154,  131,  103,
      101
    } ;

static const short int yy_def[242] =
    {   0,
      220,    1,  220,    3,  220,  220,  220,  220,  221,  222,
      223,  220,  220,  224,  220,  224,  224,  224,  224,  224,
      224,  224,  224,  224,  224,  224,  224,  220,  220,  225,
      226,  227,  220,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  221,  220,  220,  221,  222,  223,  224,  224,
      224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
      224,  224,  224,  224,  228,  225,  220,  225,  229,  226,
      220,  226,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  224,  224,  224,
      224,  224,  224,  224,  224,  224,  224,  224,  224,  224,

      224,  224,  224,  224,  220,  228,  230,  228,  108,  220,
      229,  231,  229,  113,  227,  227,  227,  227,  227,   81,
      227,  227,  227,  227,  227,  224,  224,  224,  224,  224,
      224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
      224,  224,  220,  230,  108,  108,  231,  113,  113,  227,
      227,  227,  227,  227,  227,  227,  227,  224,  224,  224,
      224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
      232,  233,  108,  234,  235,  113,  227,  227,  224,  224,
      224,  224,  224,  224,  224,  224,  224,  224,  224,  236,
      237,  146,  238,  239,  149,  227,  224,  224,  224,  224,

      224,  224,  224,  224,  240,  241,  227,  224,  224,  224,
      224,  224,  237,  239,  224,  224,  224,  224,  224,    0,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220
    } ;

static const short int yy_nxt[551] =
    {   0,
        6,    7,    8,    7,    6,    9,   10,   11,    6,   12,
       13,   14,   15,   14,   14,   14,   14,   14,   14,   14,
       14,   14,   14,   14,    6,   16,   17,   18,   19,   14,
       20,   21,   14,   22,   14,   23,   24,   14,   14,   25,
       26,   14,   14,   14,   27,   14,   14,   28,   29,    6,
        7,    8,    7,    6,   30,   10,    6,   31,    6,    6,
       32,   33,   34,   35,   36,   33,    6,   37,   37,   37,
       38,   39,   37,    6,   37,   37,   37,   37,   37,   40,
       37,   37,   37,   37,   37,   37,   41,   37,   37,   37,
       37,   42,   37,   37,   37,   37,   33,   33,   44,   50,

       54,   45,   56,   65,   65,  214,   51,  213,   67,   69,
       69,   55,   57,   74,   75,   76,   79,   71,   78,   78,
       46,   77,   80,   79,   82,   82,   81,   68,   44,   80,
      105,   45,   80,   72,   97,  112,  102,   98,  107,   80,
      103,   65,   65,  110,   69,   69,   67,  112,   81,  106,
       46,   65,   71,   78,   78,  143,  143,   79,  206,  111,
       69,   78,   78,   80,  107,   68,  115,   81,   72,   79,
       82,   82,  147,   80,  144,   80,  115,  116,  116,  108,
      118,  109,  117,  119,  119,   80,  116,  116,  113,   81,
      114,   80,  117,  120,  120,  205,  150,  120,  120,  151,

      151,   80,  119,  119,  120,  120,  120,  120,  120,  120,
       79,   82,   82,  194,  152,  193,   80,  153,  153,  119,
      119,  151,  151,  151,  151,  191,   80,  105,  107,  107,
      107,  153,  153,  153,  153,  190,  145,  145,  219,  218,
      145,  145,  217,  220,  216,  215,  106,  145,  145,  145,
      145,  145,  145,  146,  146,  122,  212,  146,  146,  211,
      210,  209,  208,  207,  146,  146,  146,  146,  146,  146,
      110,  171,  204,  172,  203,  202,  148,  148,  201,  200,
      148,  148,  199,  198,  197,  196,  111,  148,  148,  148,
      148,  148,  148,  149,  149,  189,  188,  149,  149,  187,

      186,  112,  112,  112,  149,  149,  149,  149,  149,  149,
      173,  173,  185,  184,  173,  173,  220,  183,  182,  181,
      180,  173,  173,  173,  173,  173,  173,   66,   66,  179,
      178,   66,   66,  177,  170,  169,  168,  167,   66,   66,
       66,   66,   66,   66,  174,  166,  175,  176,  176,  165,
      164,  176,  176,  163,  162,  161,  160,  159,  176,  176,
      176,  176,  176,  176,   70,   70,  158,  157,   70,   70,
      156,  155,  154,  142,  141,   70,   70,   70,   70,   70,
       70,  192,  192,  140,  139,  192,  192,  138,  137,  136,
      135,  134,  192,  192,  192,  192,  192,  192,  195,  195,

      133,  132,  195,  195,  131,  130,  129,  128,  127,  195,
      195,  195,  195,  195,  195,   43,   43,   43,   43,   43,
       43,   47,  126,   47,   47,   47,   47,   48,  125,   48,
       48,   48,   48,   49,   49,   49,   66,  124,   66,   66,
       66,   66,   70,  123,   70,   70,   70,   70,   73,   73,
       65,  122,   65,   65,   65,   65,   69,  121,   69,   69,
       69,   69,  107,  107,  107,  107,  112,  112,  112,  112,
       83,  104,  101,  100,   99,   96,   95,   94,   93,   92,
       91,   90,   89,   88,  220,   87,   86,   85,   84,   83,
       64,   63,   62,   61,   60,   59,   58,   53,   52,  220,

        5,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220
    } ;

static const short int yy_chk[551] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    9,   16,

       19,    9,   20,   30,   30,  241,   16,  240,   30,   31,
       31,   19,   20,   32,   32,   32,   35,   31,   34,   34,
        9,   32,   35,   36,   36,   36,   35,   30,   43,   36,
       65,   43,   35,   31,   59,  239,   63,   59,   68,   36,
       63,   66,   66,   69,   70,   70,   66,   72,   35,   65,
       43,   68,   70,   74,   74,  107,  112,   75,  238,   69,
       72,   78,   78,   75,  237,   66,   78,   75,   70,   76,
       76,   76,  112,   75,  107,   76,   78,   79,   79,   68,
       80,   68,   79,   80,   80,   76,  116,  116,   72,   75,
       72,  116,   79,   81,   81,  236,  115,   81,   81,  115,

      115,  116,  118,  118,   81,   81,   81,   81,   81,   81,
       82,   82,   82,  235,  117,  234,   82,  117,  117,  119,
      119,  150,  150,  151,  151,  233,   82,  108,  144,  144,
      144,  152,  152,  153,  153,  232,  108,  108,  216,  215,
      108,  108,  211,  144,  210,  208,  108,  108,  108,  108,
      108,  108,  108,  109,  109,  207,  204,  109,  109,  203,
      202,  199,  198,  196,  109,  109,  109,  109,  109,  109,
      113,  144,  189,  144,  188,  187,  113,  113,  186,  185,
      113,  113,  184,  180,  179,  177,  113,  113,  113,  113,
      113,  113,  113,  114,  114,  170,  169,  114,  114,  168,

      167,  147,  147,  147,  114,  114,  114,  114,  114,  114,
      145,  145,  166,  165,  145,  145,  147,  163,  162,  161,
      160,  145,  145,  145,  145,  145,  145,  146,  146,  158,
      155,  146,  146,  154,  142,  141,  140,  135,  146,  146,
      146,  146,  146,  146,  147,  134,  147,  148,  148,  133,
      132,  148,  148,  131,  130,  129,  128,  127,  148,  148,
      148,  148,  148,  148,  149,  149,  126,  125,  149,  149,
      124,  123,  121,  104,  103,  149,  149,  149,  149,  149,
      149,  173,  173,  102,  101,  173,  173,  100,   99,   98,
       97,   96,  173,  173,  173,  173,  173,  173,  176,  176,

       95,   94,  176,  176,   93,   92,   91,   90,   89,  176,
      176,  176,  176,  176,  176,  221,  221,  221,  221,  221,
      221,  222,   88,  222,  222,  222,  222,  223,   87,  223,
      223,  223,  223,  224,  224,  224,  225,   86,  225,  225,
      225,  225,  226,   85,  226,  226,  226,  226,  227,  227,
      228,   84,  228,  228,  228,  228,  229,   83,  229,  229,
      229,  229,  230,  230,  230,  230,  231,  231,  231,  231,
       77,   64,   62,   61,   60,   58,   57,   56,   55,   54,
       53,   52,   51,   50,   46,   42,   41,   40,   39,   38,
       27,   26,   25,   24,   23,   22,   21,   18,   17,    5,

      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220
    } ;

static yy_state_type yy_last_accepting_state;
static YY_CHAR *yy_last_accepting_cpos;

/* the intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0

/* these variables are all declared out here so that section 3 code can
 * manipulate them
 */
/* points to current character in buffer */
static YY_CHAR *yy_c_buf_p = (YY_CHAR *) 0;
static int yy_init = 1;         /* whether we need to initialize */
static int yy_start = 0;        /* start state number */

/* flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

static yy_state_type yy_get_previous_state ( void );
static yy_state_type yy_try_NUL_trans ( yy_state_type current_state );
static int yy_get_next_buffer ( void );
static void yyunput ( YY_CHAR c, YY_CHAR *buf_ptr );

/* jbk added static in front all these */
static void yyrestart ( FILE *input_file );
static void yy_switch_to_buffer ( YY_BUFFER_STATE new_buffer );
static void yy_load_buffer_state ( void );
static YY_BUFFER_STATE yy_create_buffer ( FILE *file, int size );
static void yy_delete_buffer ( YY_BUFFER_STATE b );
static void yy_init_buffer ( YY_BUFFER_STATE b, FILE *file );

#define yy_new_buffer yy_create_buffer

#ifdef yyneed_input
#ifdef __cplusplus
static int yyinput ( void );
#else
static int input ( void );
#endif
#endif

YY_DECL
    {
    register yy_state_type yy_current_state;
    register YY_CHAR *yy_cp, *yy_bp;
    register int yy_act;




    if ( yy_init )
        {
        YY_USER_INIT;

        if ( ! yy_start )
            yy_start = 1;       /* first start state */

        if ( ! yyin )
            yyin = stdin;

        if ( ! yyout )
            yyout = stdout;

        if ( yy_current_buffer )
            yy_init_buffer( yy_current_buffer, yyin );
        else
            yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE );

        yy_load_buffer_state();

        yy_init = 0;
        }

    while ( 1 )         /* loops until end-of-file is reached */
        {
        yy_cp = yy_c_buf_p;

        /* support of yytext */
        *yy_cp = yy_hold_char;

        /* yy_bp points to the position in yy_ch_buf of the start of the
         * current run.
         */
        yy_bp = yy_cp;

	yy_current_state = yy_start;
yy_match:
	do
	    {
	    YY_CHAR yy_c = yy_ec[(int)*yy_cp];
	    if ( yy_accept[yy_current_state] )
		{
		yy_last_accepting_state = yy_current_state;
		yy_last_accepting_cpos = yy_cp;
		}
	    while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = yy_def[yy_current_state];
		if ( yy_current_state >= 221 )
		    yy_c = yy_meta[(int)yy_c];
		}
	    yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
	    ++yy_cp;
	    }
	while ( yy_base[yy_current_state] != 501 );

yy_find_action:
	yy_act = yy_accept[yy_current_state];

        YY_DO_BEFORE_ACTION;
        YY_USER_ACTION;

do_action:      /* this label is used only to access EOF actions */


        switch ( yy_act )
            {
	    case 0: /* must backtrack */
	    /* undo the effects of YY_DO_BEFORE_ACTION */
	    *yy_cp = yy_hold_char;
	    yy_cp = yy_last_accepting_cpos;
	    yy_current_state = yy_last_accepting_state;
	    goto yy_find_action;

case 1:
# line 64 "../dbStatic/dbLex.l"
return(tokenINCLUDE);
	YY_BREAK
case 2:
# line 65 "../dbStatic/dbLex.l"
return(tokenPATH);
	YY_BREAK
case 3:
# line 66 "../dbStatic/dbLex.l"
return(tokenADDPATH);
	YY_BREAK
case 4:
# line 67 "../dbStatic/dbLex.l"
return(tokenMENU);
	YY_BREAK
case 5:
# line 68 "../dbStatic/dbLex.l"
return(tokenCHOICE);
	YY_BREAK
case 6:
# line 69 "../dbStatic/dbLex.l"
return(tokenRECORDTYPE);
	YY_BREAK
case 7:
# line 70 "../dbStatic/dbLex.l"
return(tokenFIELD);
	YY_BREAK
case 8:
# line 71 "../dbStatic/dbLex.l"
return(tokenDEVICE);
	YY_BREAK
case 9:
# line 72 "../dbStatic/dbLex.l"
return(tokenDRIVER);
	YY_BREAK
case 10:
# line 73 "../dbStatic/dbLex.l"
return(tokenLINK);
	YY_BREAK
case 11:
# line 74 "../dbStatic/dbLex.l"
return(tokenBREAKTABLE);
	YY_BREAK
case 12:
# line 75 "../dbStatic/dbLex.l"
return(tokenRECORD);
	YY_BREAK
case 13:
# line 76 "../dbStatic/dbLex.l"
return(tokenGRECORD);
	YY_BREAK
case 14:
# line 77 "../dbStatic/dbLex.l"
return(tokenALIAS);
	YY_BREAK
case 15:
# line 78 "../dbStatic/dbLex.l"
return(tokenINFO);
	YY_BREAK
case 16:
# line 79 "../dbStatic/dbLex.l"
return(tokenREGISTRAR);
	YY_BREAK
case 17:
# line 80 "../dbStatic/dbLex.l"
return(tokenFUNCTION);
	YY_BREAK
case 18:
# line 81 "../dbStatic/dbLex.l"
return(tokenVARIABLE);
	YY_BREAK
case 19:
# line 83 "../dbStatic/dbLex.l"
{ /* unquoted string or number */
    yylval.Str = dbmfStrdup((char *) yytext);
    return(tokenSTRING);
}
	YY_BREAK
case 20:
# line 88 "../dbStatic/dbLex.l"
{ /* quoted string */
    yylval.Str = dbmfStrdup((char *) yytext+1);
    yylval.Str[strlen(yylval.Str)-1] = '\0';
    return(tokenSTRING);
}
	YY_BREAK
case 21:
# line 94 "../dbStatic/dbLex.l"
{ /*C definition in recordtype*/
    yylval.Str = dbmfStrdup((char *) yytext+1);
    return(tokenCDEFS);
}
	YY_BREAK
case 22:
# line 99 "../dbStatic/dbLex.l"
return(yytext[0]);
	YY_BREAK
case 23:
# line 100 "../dbStatic/dbLex.l"
return(yytext[0]);
	YY_BREAK
case 24:
# line 101 "../dbStatic/dbLex.l"
return(yytext[0]);
	YY_BREAK
case 25:
# line 102 "../dbStatic/dbLex.l"
return(yytext[0]);
	YY_BREAK
case 26:
# line 103 "../dbStatic/dbLex.l"
return(yytext[0]);
	YY_BREAK
case 27:
# line 105 "../dbStatic/dbLex.l"
return jsonNULL;
	YY_BREAK
case 28:
# line 106 "../dbStatic/dbLex.l"
return jsonTRUE;
	YY_BREAK
case 29:
# line 107 "../dbStatic/dbLex.l"
return jsonFALSE;
	YY_BREAK
case 30:
# line 109 "../dbStatic/dbLex.l"
return yytext[0];
	YY_BREAK
case 31:
# line 111 "../dbStatic/dbLex.l"
{
    yylval.Str = dbmfStrdup((char *) yytext);
    return jsonSTRING;
}
	YY_BREAK
case 32:
# line 116 "../dbStatic/dbLex.l"
{
    yylval.Str = dbmfStrdup((char *) yytext);
    return jsonNUMBER;
}
	YY_BREAK
case 33:
# line 121 "../dbStatic/dbLex.l"
{
    yylval.Str = dbmfStrdup((char *) yytext);
    return jsonBARE;
}
	YY_BREAK
case 34:
# line 126 "../dbStatic/dbLex.l"
;
	YY_BREAK
case 35:
# line 128 "../dbStatic/dbLex.l"
;
	YY_BREAK
  /* Error patterns */
case 36:
# line 133 "../dbStatic/dbLex.l"
{
    yyerrorAbort("Newline in string, closing quote missing");
}
	YY_BREAK
case 37:
# line 137 "../dbStatic/dbLex.l"
{
    yyerrorAbort("Bad character in JSON string");
}
	YY_BREAK
case 38:
# line 140 "../dbStatic/dbLex.l"
{
    yyerrorAbort("Bad character in JSON string");
}
	YY_BREAK
case 39:
# line 144 "../dbStatic/dbLex.l"
{
    char message[40];
    YY_BUFFER_STATE *dummy=0;

    if (isprint((int) yytext[0])) {
        sprintf(message, "Invalid character '%c'", yytext[0]);
    }
    else {
        sprintf(message, "Invalid character 0x%2.2x", yytext[0]);
    }
    yyerrorAbort(message);
    /*The following suppresses compiler warning messages*/
    if(FALSE) yyunput('c',(unsigned char *) message);
    if(FALSE) yy_switch_to_buffer(*dummy);
}
	YY_BREAK
case 40:
# line 160 "../dbStatic/dbLex.l"
ECHO;
	YY_BREAK
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(JSON):
    yyterminate();

            case YY_END_OF_BUFFER:
                {
                /* amount of text matched not including the EOB char */
                int yy_amount_of_matched_text = yy_cp - yytext - 1;

                /* undo the effects of YY_DO_BEFORE_ACTION */
                *yy_cp = yy_hold_char;

                /* note that here we test for yy_c_buf_p "<=" to the position
                 * of the first EOB in the buffer, since yy_c_buf_p will
                 * already have been incremented past the NUL character
                 * (since all states make transitions on EOB to the end-
                 * of-buffer state).  Contrast this with the test in yyinput().
                 */
                if ( yy_c_buf_p <= &yy_current_buffer->yy_ch_buf[yy_n_chars] )
                    /* this was really a NUL */
                    {
                    yy_state_type yy_next_state;

                    yy_c_buf_p = yytext + yy_amount_of_matched_text;

                    yy_current_state = yy_get_previous_state();

                    /* okay, we're now positioned to make the
                     * NUL transition.  We couldn't have
                     * yy_get_previous_state() go ahead and do it
                     * for us because it doesn't know how to deal
                     * with the possibility of jamming (and we
                     * don't want to build jamming into it because
                     * then it will run more slowly)
                     */

                    yy_next_state = yy_try_NUL_trans( yy_current_state );

                    yy_bp = yytext + YY_MORE_ADJ;

                    if ( yy_next_state )
                        {
                        /* consume the NUL */
                        yy_cp = ++yy_c_buf_p;
                        yy_current_state = yy_next_state;
                        goto yy_match;
                        }

                    else
                        {
                        goto yy_find_action;
                        }
                    }

                else switch ( yy_get_next_buffer() )
                    {
                    case EOB_ACT_END_OF_FILE:
                        {
                        yy_did_buffer_switch_on_eof = 0;

                        if ( yywrap() )
                            {
                            /* note: because we've taken care in
                             * yy_get_next_buffer() to have set up yytext,
                             * we can now set up yy_c_buf_p so that if some
                             * total hoser (like flex itself) wants
                             * to call the scanner after we return the
                             * YY_NULL, it'll still work - another YY_NULL
                             * will get returned.
                             */
                            yy_c_buf_p = yytext + YY_MORE_ADJ;

                            yy_act = YY_STATE_EOF((yy_start - 1) / 2);
                            goto do_action;
                            }

                        else
                            {
                            if ( ! yy_did_buffer_switch_on_eof )
                                YY_NEW_FILE;
                            }
                        }
                        break;

                    case EOB_ACT_CONTINUE_SCAN:
                        yy_c_buf_p = yytext + yy_amount_of_matched_text;

                        yy_current_state = yy_get_previous_state();

                        yy_cp = yy_c_buf_p;
                        yy_bp = yytext + YY_MORE_ADJ;
                        goto yy_match;

                    case EOB_ACT_LAST_MATCH:
                        yy_c_buf_p =
                            &yy_current_buffer->yy_ch_buf[yy_n_chars];

                        yy_current_state = yy_get_previous_state();

                        yy_cp = yy_c_buf_p;
                        yy_bp = yytext + YY_MORE_ADJ;
                        goto yy_find_action;
                    }
                break;
                }

            default:
#ifdef FLEX_DEBUG
                printf( "action # %d\n", yy_act );
#endif
                YY_FATAL_ERROR(
                        "fatal flex scanner internal error--no action found" );
            }
        }
    }


/* yy_get_next_buffer - try to read in a new buffer
 *
 * synopsis
 *     int yy_get_next_buffer();
 *
 * returns a code representing an action
 *     EOB_ACT_LAST_MATCH -
 *     EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *     EOB_ACT_END_OF_FILE - end of file
 */

static int yy_get_next_buffer( void )

    {
    register YY_CHAR *dest = yy_current_buffer->yy_ch_buf;
    register YY_CHAR *source = yytext - 1; /* copy prev. char, too */
    register int number_to_move, i;
    int ret_val;

    if ( yy_c_buf_p > &yy_current_buffer->yy_ch_buf[yy_n_chars + 1] )
        YY_FATAL_ERROR(
                "fatal flex scanner internal error--end of buffer missed" );

    /* try to read more data */

    /* first move last chars to start of buffer */
    number_to_move = yy_c_buf_p - yytext;

    for ( i = 0; i < number_to_move; ++i )
        *(dest++) = *(source++);

    if ( yy_current_buffer->yy_eof_status != EOF_NOT_SEEN )
        /* don't do the read, it's not guaranteed to return an EOF,
         * just force an EOF
         */
        yy_n_chars = 0;

    else
        {
        int num_to_read = yy_current_buffer->yy_buf_size - number_to_move - 1;

        if ( num_to_read > YY_READ_BUF_SIZE )
            num_to_read = YY_READ_BUF_SIZE;

        else if ( num_to_read <= 0 )
            YY_FATAL_ERROR( "fatal error - scanner input buffer overflow" );

        /* read in more data */
        YY_INPUT( (&yy_current_buffer->yy_ch_buf[number_to_move]),
                  yy_n_chars, num_to_read );
        }

    if ( yy_n_chars == 0 )
        {
        if ( number_to_move - YY_MORE_ADJ == 1 )
            {
            ret_val = EOB_ACT_END_OF_FILE;
            yy_current_buffer->yy_eof_status = EOF_DONE;
            }

        else
            {
            ret_val = EOB_ACT_LAST_MATCH;
            yy_current_buffer->yy_eof_status = EOF_PENDING;
            }
        }

    else
        ret_val = EOB_ACT_CONTINUE_SCAN;

    yy_n_chars += number_to_move;
    yy_current_buffer->yy_ch_buf[yy_n_chars] = YY_END_OF_BUFFER_CHAR;
    yy_current_buffer->yy_ch_buf[yy_n_chars + 1] = YY_END_OF_BUFFER_CHAR;

    /* yytext begins at the second character in yy_ch_buf; the first
     * character is the one which preceded it before reading in the latest
     * buffer; it needs to be kept around in case it's a newline, so
     * yy_get_previous_state() will have with '^' rules active
     */

    yytext = &yy_current_buffer->yy_ch_buf[1];

    return ( ret_val );
    }


/* yy_get_previous_state - get the state just before the EOB char was reached
 *
 * synopsis
 *     yy_state_type yy_get_previous_state();
 */

static yy_state_type yy_get_previous_state( void )

    {
    register yy_state_type yy_current_state;
    register YY_CHAR *yy_cp;

    yy_current_state = yy_start;

    for ( yy_cp = yytext + YY_MORE_ADJ; yy_cp < yy_c_buf_p; ++yy_cp )
        {
	YY_CHAR yy_c = (*yy_cp ? yy_ec[(int)*yy_cp] : 1);
	if ( yy_accept[yy_current_state] )
	    {
	    yy_last_accepting_state = yy_current_state;
	    yy_last_accepting_cpos = yy_cp;
	    }
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
	    {
	    yy_current_state = yy_def[yy_current_state];
	    if ( yy_current_state >= 221 )
		yy_c = yy_meta[(int)yy_c];
	    }
	yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
        }

    return ( yy_current_state );
    }


/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *     next_state = yy_try_NUL_trans( current_state );
 */

static yy_state_type yy_try_NUL_trans( register yy_state_type yy_current_state )
    {
    register int yy_is_jam;
    YY_CHAR *yy_cp = yy_c_buf_p;

    YY_CHAR yy_c = 1;
    if ( yy_accept[yy_current_state] )
	{
	yy_last_accepting_state = yy_current_state;
	yy_last_accepting_cpos = yy_cp;
	}
    while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
	{
	yy_current_state = yy_def[yy_current_state];
	if ( yy_current_state >= 221 )
	    yy_c = yy_meta[(int)yy_c];
	}
    yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
    yy_is_jam = (yy_base[yy_current_state] == 501);

    return ( yy_is_jam ? 0 : yy_current_state );
    }


static void yyunput( YY_CHAR c, register YY_CHAR *yy_bp )
    {
    register YY_CHAR *yy_cp = yy_c_buf_p;

    /* undo effects of setting up yytext */
    *yy_cp = yy_hold_char;

    if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
        { /* need to shift things up to make room */
        register int number_to_move = yy_n_chars + 2; /* +2 for EOB chars */
        register YY_CHAR *dest =
            &yy_current_buffer->yy_ch_buf[yy_current_buffer->yy_buf_size + 2];
        register YY_CHAR *source =
            &yy_current_buffer->yy_ch_buf[number_to_move];

        while ( source > yy_current_buffer->yy_ch_buf )
            *--dest = *--source;

        yy_cp += dest - source;
        yy_bp += dest - source;
        yy_n_chars = yy_current_buffer->yy_buf_size;

        if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
            YY_FATAL_ERROR( "flex scanner push-back overflow" );
        }

    if ( yy_cp > yy_bp && yy_cp[-1] == '\n' )
        yy_cp[-2] = '\n';

    *--yy_cp = c;

    /* note: the formal parameter *must* be called "yy_bp" for this
     *       macro to now work correctly
     */
    YY_DO_BEFORE_ACTION; /* set up yytext again */
    }


#ifdef yyneed_input
#ifdef __cplusplus
static int yyinput( void )
#else
static int input( void )
#endif

    {
    int c;
    YY_CHAR *yy_cp = yy_c_buf_p;

    *yy_cp = yy_hold_char;

    if ( *yy_c_buf_p == YY_END_OF_BUFFER_CHAR )
        {
        /* yy_c_buf_p now points to the character we want to return.
         * If this occurs *before* the EOB characters, then it's a
         * valid NUL; if not, then we've hit the end of the buffer.
         */
        if ( yy_c_buf_p < &yy_current_buffer->yy_ch_buf[yy_n_chars] )
            /* this was really a NUL */
            *yy_c_buf_p = '\0';

        else
            { /* need more input */
            yytext = yy_c_buf_p;
            ++yy_c_buf_p;

            switch ( yy_get_next_buffer() )
                {
                case EOB_ACT_END_OF_FILE:
                    {
                    if ( yywrap() )
                        {
                        yy_c_buf_p = yytext + YY_MORE_ADJ;
                        return ( EOF );
                        }

                    YY_NEW_FILE;

#ifdef __cplusplus
                    return ( yyinput() );
#else
                    return ( input() );
#endif
                    }
                    break;

                case EOB_ACT_CONTINUE_SCAN:
                    yy_c_buf_p = yytext + YY_MORE_ADJ;
                    break;

                case EOB_ACT_LAST_MATCH:
#ifdef __cplusplus
                    YY_FATAL_ERROR( "unexpected last match in yyinput()" );
#else
                    YY_FATAL_ERROR( "unexpected last match in input()" );
#endif
                }
            }
        }

    c = *yy_c_buf_p;
    yy_hold_char = *++yy_c_buf_p;

    return ( c );
    }
#endif /* yyneed_input */


/* jbk added static in front of func */
static void yyrestart( FILE *input_file )
    {
    if ( yy_current_buffer )
        yy_init_buffer( yy_current_buffer, input_file );
    else
        yy_current_buffer = yy_create_buffer( input_file, YY_BUF_SIZE );

    yy_load_buffer_state();
    }


/* jbk added static in front of func */
static void yy_switch_to_buffer( YY_BUFFER_STATE new_buffer )
    {
    if ( yy_current_buffer == new_buffer )
        return;

    if ( yy_current_buffer )
        {
        /* flush out information for old buffer */
        *yy_c_buf_p = yy_hold_char;
        yy_current_buffer->yy_buf_pos = yy_c_buf_p;
        yy_current_buffer->yy_n_chars = yy_n_chars;
        }

    yy_current_buffer = new_buffer;
    yy_load_buffer_state();

    /* we don't actually know whether we did this switch during
     * EOF (yywrap()) processing, but the only time this flag
     * is looked at is after yywrap() is called, so it's safe
     * to go ahead and always set it.
     */
    yy_did_buffer_switch_on_eof = 1;
    }


/* jbk added static in front of func */
static void yy_load_buffer_state( void )
    {
    yy_n_chars = yy_current_buffer->yy_n_chars;
    yytext = yy_c_buf_p = yy_current_buffer->yy_buf_pos;
    yyin = yy_current_buffer->yy_input_file;
    yy_hold_char = *yy_c_buf_p;
    }


/* jbk added static in front of func */
static YY_BUFFER_STATE yy_create_buffer( FILE *file, int size )
    {
    YY_BUFFER_STATE b;

    b = (YY_BUFFER_STATE) malloc( sizeof( struct yy_buffer_state ) );

    if ( ! b )
        YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

    b->yy_buf_size = size;

    /* yy_ch_buf has to be 2 characters longer than the size given because
     * we need to put in 2 end-of-buffer characters.
     */
    b->yy_ch_buf = (YY_CHAR *) malloc( (unsigned) (b->yy_buf_size + 2) );

    if ( ! b->yy_ch_buf )
        YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

    yy_init_buffer( b, file );

    return ( b );
    }


/* jbk added static in front of func */
static void yy_delete_buffer( YY_BUFFER_STATE b )
    {
    if ( b == yy_current_buffer )
        yy_current_buffer = (YY_BUFFER_STATE) 0;

    free( (char *) b->yy_ch_buf );
    free( (char *) b );
    }


/* jbk added static in front of func */
static void yy_init_buffer( YY_BUFFER_STATE b, FILE *file )
    {
    b->yy_input_file = file;

    /* we put in the '\n' and start reading from [1] so that an
     * initial match-at-newline will be true.
     */

    b->yy_ch_buf[0] = '\n';
    b->yy_n_chars = 1;

    /* we always need two end-of-buffer characters.  The first causes
     * a transition to the end-of-buffer state.  The second causes
     * a jam in that state.
     */
    b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;
    b->yy_ch_buf[2] = YY_END_OF_BUFFER_CHAR;

    b->yy_buf_pos = &b->yy_ch_buf[1];

    b->yy_eof_status = EOF_NOT_SEEN;
    }

static int yyterminate_internal( void )
{
        /* jbk fix - buffer created by yy_create_buffer needs to be freed */
        yy_delete_buffer(yy_current_buffer);
        yy_current_buffer=NULL;
        return YY_NULL;
}

# line 160 "../dbStatic/dbLex.l"

